// This wants to be a "generic" library for ad9833, ad9850 and ad9851.
// currently, only ad9851 is supported and tested.
// ad9850 is supported but not tested
// ad9833 might just not work at all
#pragma once

#include <stdint.h>

#define AD98_MODEL_AD9833 (unsigned char) 0
#define AD98_MODEL_AD9850 (unsigned char) 1
#define AD98_MODEL_AD9851 (unsigned char) 2
#define AD98_MODELS_NUM 3

#define AD98_AD9833_CLOCK  25000000
#define AD98_AD9850_CLOCK 125000000
#define AD98_AD9851_CLOCK 180000000
#define AD98_AD9833_TUNING 171.8 // (2**32)/AD98_AD9850_CLOCK
#define AD98_AD9850_TUNING 34.36 // (2**32)/AD98_AD9850_CLOCK
#define AD98_AD9851_TUNING 23.86 // (2**32)/AD98_AD9851_CLOCK

typedef struct {
    unsigned char model;  // 0 for ad9833, 1 for ad9850 and 2 for ad9851
    // same port for all pins!
    uint32_t gpioport;
    // pins
    uint16_t clock;
    uint16_t load; // aka FQ_UD aka FSYNC (on 9833)
    uint16_t data;
    uint16_t reset; // puoi anche metterlo a massa, in tal caso segnalo come 0 così non viene usato un pin inutile
} ad98_dds;

void ad98_init(ad98_dds);
void ad98_set_frequency(ad98_dds, double);
